<html>
    <head>
        <meta charset="utf-8" />
        <title>Human Reproductive System</title>

        <style>
            @import url('Quicksand-Regular.ttf');

            html {
                background-color: #efefef;
            }

            body {
                font-family: 'Quicksand', sans-serif;
                background-color: #bdd4de;
                margin: 6em;
                padding: 2em;
            }

            h1, h2, h3 {
                font-weight: 400;
            }

            h1 {
                color: #2b3a42;
            }

            h2 {
                color: #3f5765;
            }

            h3 {
                font-size: 0.9em;
                color: #888;
            }

            #console { 
                overflow-x: none;
                overflow-y: scroll;
                padding-left: 1em;
                width: 100%;
                height: 50%;
                font-family: monospace;
                background-color: #2b3a42;
                color: #ff530d;
                font-size: 1.2em;
            } 
        </style>
        <script>
            var config = {
                time: 60 * 5,
                extracts: ['1', '2', '4', '5a', '5b'],
                coda: 'coda',
                speech: {
                    rubric: "rubric",
                    claxon: "claxon",
                    failure: ["wrong", "false", "incorrect", "invalid"],
                    extractPostfix: "-speech",
                    timeout: "timeout",
                    success: "congrats",
                },
                volumes: {
                    speech: 0.5,
                    extracts: 1.0,
                    claxon: 0.9,
                },
            };

            var audio = {
                extracts: [],
                speech: {},
                all: [],
            };

            var started = false;
            var clock;
            var elapsed = 0;

            var say = function(message) {
                var cnsl = document.getElementById("console");
                cnsl.innerHTML += "<p>[" 
                    + elapsed.toFixed(1) + "] " + message + "</p>";
                cnsl.scrollTop = cnsl.scrollHeight;
            };

            var ready = function() {
                say("Ready to perform. Press spacebar to begin.");
            };

            var reset = function() {
                started = false;
                elapsed = 0;
                stopClock();
                ready();
            };

            var stopAll = function() {
                audio.all.forEach(function(a) {
                    a.pause();
                    a.currentTime = 0;
                });
            };

            var timeout = function() {
                stopClock();
                stopAll();
                say("Timeout!");
                var old = audio.speech.claxon.onended;
                audio.speech.claxon.onended = function() {
                    audio.speech.timeout.play();
                    audio.speech.claxon.onended = old;
                };
                audio.speech.claxon.play();
            };

            var tick = function() {
                elapsed += 0.1;

                if (elapsed >= config.time)
                    timeout();
            };

            var extract = function() {
                var index = Math.floor(Math.random() * config.extracts.length);
                say("Chose extract " + config.extracts[index]);
                audio.speech.extracts[index].play();
            };

            var start = function() {
                stopAll();
                say("We shall begin.");
                say("Press spacebar when you detect an error.");
                audio.speech.rubric.play();
            };

            var startClock = function() {
                clock = setInterval(tick, 100);
            };

            var stopClock = function() {
                window.clearInterval(clock);
            };

            var failure = function() {
                stopAll();
                say("Failure!");
                audio.speech.claxon.play();
            };

            var success = function() {
                say("Success.");
                audio.speech.success.play();
            };

            var playFailureSpeech = function() {
                var index = Math.floor(Math.random() * config.speech.failure.length);
                audio.speech.failure[index].play();
            };

            window.onload = function() {
                var audioCont = document.getElementById("audio");

                var regAudio = function(src, volume) {
                    var a = document.createElement('audio');
                    a.src = "audio/" + src + ".mp3";
                    a.volume = volume;
                    a.load();
                    a.loop = false;
                    audioCont.appendChild(a);
                    audio.all.push(a);
                    return a;
                };

                ['rubric', 'claxon', 'timeout', 'success'].forEach(function(part) {
                    audio.speech[part] = regAudio(config.speech[part], config.volumes.speech);
                });

                audio.coda = regAudio(config.coda, config.volumes.extracts);
                audio.coda.onended = function() {
                    reset();
                };

                audio.speech.success.onended = function() {
                    reset();
                };

                audio.speech.claxon.volume = config.volumes.claxon;
                audio.speech.timeout.onended = function() {
                    audio.coda.play();
                };

                audio.speech.failure = [];
                config.speech.failure.forEach(function(fail, idx) {
                    var a = regAudio(fail, config.volumes.speech);
                    a.onended = extract;
                    audio.speech.failure[idx] = a;
                });

                audio.speech.rubric.onended = function() {
                    startClock();
                    started = true;
                    extract();
                };

                audio.speech.claxon.onended = playFailureSpeech;

                audio.speech.extracts = [];
                config.extracts.forEach(function(extract, idx) {
                    var a = regAudio('extract' + extract, config.volumes.extracts);
                    var s = regAudio('extract' + extract + config.speech.extractPostfix, config.volumes.speech);
                    audio.extracts[idx] = a;
                    audio.speech.extracts[idx] = s;
                    s.onended = function() {
                        audio.extracts[idx].play();
                    };

                    a.onended = function() {
                        success();
                    };
                });

                reset();
            };

            var trigger = function() {
                if (!started)
                    start();
                else
                    failure();
            };

            window.ontouchstart = trigger;
            window.onkeydown = function(e) {
                if (e.keyCode != 32)
                    return;

                trigger();
            };
    </script>
    </head>
    <body>
        <h1>human reproductive system</h1>
        <h2>colm molloy, 2018</h2>
        <h3>automaton --- peter bridgman</h3>
        <div id="console">
        </div>
        <div id="audio">
        </div>
    </body>
</html>
